<script setup lang="ts">
import { useWorkflowStore } from "@/stores/workflows";
import {
  NextflowVersion,
  type WorkflowOut,
  type WorkflowVersionOut,
  type WorkflowVersionMetadataIn,
} from "@/client/types.gen";
import { computed, onMounted, reactive, ref } from "vue";
import BootstrapToast from "@/components/BootstrapToast.vue";
import { Toast } from "bootstrap";

const props = defineProps<{
  workflowId: string;
  workflowVersionId: string;
}>();

const metadata = reactive<WorkflowVersionMetadataIn>({
  default_container: undefined,
  nextflow_version: NextflowVersion["22_10_0"],
  nextflow_config: undefined,
});

const formState = reactive<{
  validated: boolean;
  loading: boolean;
  containerError: boolean;
}>({
  validated: false,
  loading: true,
  containerError: false,
});

const workflowRepository = useWorkflowStore();

const metadataForm = ref<HTMLFormElement | undefined>(undefined);
const containerInput = ref<HTMLInputElement | undefined>(undefined);
let successToast: Toast | undefined;

const workflow = computed<WorkflowOut | undefined>(
  () => workflowRepository.workflowMapping[props.workflowId ?? ""],
);
const workflowVersion = computed<WorkflowVersionOut | undefined>(
  () => workflowRepository.versionMapping[props.workflowVersionId ?? ""],
);

function updateMetadata() {
  formState.validated = true;
  formState.containerError = false;
  metadata.default_container =
    metadata.default_container?.trim().length === 0
      ? undefined
      : metadata.default_container?.trim();
  metadata.nextflow_config =
    metadata.nextflow_config?.trim().length === 0
      ? undefined
      : metadata.nextflow_config?.trim();
  containerInput.value?.setCustomValidity("");
  if (metadataForm.value?.checkValidity()) {
    formState.loading = true;
    workflowRepository
      .updateVersionMetadata(
        props.workflowId,
        props.workflowVersionId,
        metadata,
      )
      .then((metadataOut) => {
        successToast?.show();
        formState.validated = false;
        metadataOut.nextflow_config = metadata.nextflow_config;
        metadataOut.nextflow_version = metadata.nextflow_version;
        metadataOut.default_container = metadata.default_container;
      })
      .catch((err) => {
        if (
          metadata.default_container != undefined &&
          err.response.data?.["detail"].includes(
            metadata.default_container ?? "",
          )
        ) {
          containerInput.value?.setCustomValidity(
            "container image doesn't exist",
          );
          formState.containerError = true;
        }
      })
      .finally(() => {
        formState.loading = false;
      });
  }
}

onMounted(() => {
  successToast = new Toast("#update-metadata-toast");
  workflowRepository.fetchWorkflow(props.workflowId, true);
  workflowRepository
    .fetchVersionMetadata(props.workflowId, props.workflowVersionId)
    .then((meta) => {
      metadata.nextflow_version = meta.nextflow_version;
      metadata.default_container = meta.default_container;
      metadata.nextflow_config = meta.nextflow_config;
    })
    .finally(() => {
      formState.loading = false;
    });
});
</script>

<template>
  <bootstrap-toast toast-id="update-metadata-toast">
    Successfully updated metadata
  </bootstrap-toast>
  <div class="row border-bottom mb-4">
    <h2 class="mb-2">
      Update Workflow Version Metadata of {{ workflow?.name }}@{{
        workflowVersion?.version
      }}
    </h2>
  </div>
  <form
    ref="metadataForm"
    :class="{ 'was-validated': formState.validated }"
    @submit.prevent="updateMetadata()"
  >
    <div class="row mb-3">
      <div class="col">
        <label for="container-input" class="form-label"
          >Default Container</label
        >
        <input
          id="container-input"
          ref="containerInput"
          v-model="metadata.default_container"
          type="text"
          class="form-control"
          pattern="^(?:(?=[^:\/]{4,253})(?!-)[a-zA-Z0-9\-]{1,63}(?<!-)(?:\.(?!-)[a-zA-Z0-9\-]{1,63}(?<!-))*(?::[0-9]{1,5})?\/)?((?![\._\-])(?:[a-z0-9\._\-]*)(?<![\._\-])(?:\/(?![\._\-])[a-z0-9\._\-]*(?<![\._\-]))*):(?![\.\-])[a-zA-Z0-9_\.\-]{1,128}$"
          placeholder="ubuntu:22.04"
          :disabled="formState.loading"
          @change="containerInput?.setCustomValidity('')"
        />
        <div class="form-text">
          Override the default container that every Nextflow process without a
          container directives gets executed in
        </div>
        <div class="invalid-feedback">Container image does not exist</div>
      </div>
      <div class="col">
        <label for="nextflow-version-input" class="form-label"
          >Nextflow Version</label
        >
        <select
          id="nextflow-version-input"
          v-model="metadata.nextflow_version"
          class="form-select"
          required
          :disabled="formState.loading"
        >
          <option
            v-for="version in Object.values(NextflowVersion).reverse()"
            :key="version"
            :value="version"
          >
            {{ version }}
          </option>
        </select>
      </div>
    </div>
    <div class="mb-2">
      <label for="config-input" class="form-label">Nextflow config</label>
      <div class="form-text">
        <span class="text-warning"
          >USE AT YOUR OWN RISK! NO SYNTAX VALIDATION!</span
        >
        <br />
        Override the nextflow.config file in the git repository.
      </div>
      <textarea
        id="config-input"
        v-model="metadata.nextflow_config"
        class="form-control"
        rows="10"
        spellcheck="false"
        :disabled="formState.loading"
      />
    </div>
    <div class="d-grid gap-2">
      <button
        type="submit"
        class="btn btn-success btn-lh mt-3"
        :disabled="formState.loading"
      >
        Save
      </button>
    </div>
  </form>
</template>

<style scoped></style>
